proc ddhexportselected_makeframe {} {

   global prefs_ddhexportselected_last_format
   global ddhes_exportids
   global ddhes_exportdescs
   global ddhes_exp_format
   global ddhes_output_type
   global ddhes_exp_filename
   global ddhes_status
   global ddhes_filetypes
   set ddhes_exportids [ac3d exporters_get_names]
   set ddhes_exportdescs [ac3d exporters_get_descs]
   set ddhes_status "Ready to export selected geometry."
   set ddhes_filetypes {
      {{ LWO files} {*.lwo}}
      {{ OBJ files} {*.obj}}
      {{ 3DS files} {*.3ds}}
      {{ DXF files} {*.dxf}}
      {{ All files} {*}}
   }

   new_toplevel .ddhexportselected "Export selected objects"

   set ipady 1
   set lblwidth 16
   set combowidth 30
   set entrywidth 42
   set statuswidth 70

#source tcl/combobox.tcl
#package require combobox 2.2
catch {namespace import combobox::*}

   # List of exporters
   set frm [frame .ddhexportselected.frmlist]
   pack $frm -side top -fill both -expand 1
   pack configure $frm -ipady $ipady
   label $frm.lblexp -text "Export format: " -width $lblwidth -anchor w
   pack $frm.lblexp -side left
   combobox $frm.listexp -editable false -textvariable ddhes_exp_format -width $combowidth
   pack $frm.listexp -side left
   eval $frm.listexp list insert end $ddhes_exportdescs
   set result [ catch {
      set current [lsearch $ddhes_exportids "$prefs_ddhexportselected_last_format"]
   } errmsg ]
   if { $result } {
      set current 0
   }
   $frm.listexp select $current

   # Export filename
   set frm [frame .ddhexportselected.frmfile]
   pack $frm -side top -fill both -expand 1
   pack configure $frm -ipady $ipady
   label $frm.lblfile -text "Export filename: " -width $lblwidth -anchor w
   pack $frm.lblfile -side left
   entry $frm.entfile -textvariable ddhes_exp_filename -width $entrywidth
   pack $frm.entfile -side left -fill x -expand 1
   button $frm.btnfile -text "Browse..." -command {
      set res [get_exportfilename "Export selected destination" $ddhes_filetypes "" $ddhes_exp_filename]
      if {$res != "" } {
         set ddhes_exp_filename $res
      }
   }
   pack $frm.btnfile -side left

   # Go
   set frm [frame .ddhexportselected.frmbtn]
   pack $frm -side top -fill x
   pack configure $frm -ipady $ipady

   button $frm.btnapply -text "Export selected" -command {
      if { [ .ddhexportselected.frmlist.listexp curselection ] == "" } {
         tk_messageBox -message "Please select an export format" -type ok -icon warning
         return
      }
      # Trim and strip double-quotes
      set exp_filename [string map {{"} {}} $ddhes_exp_filename]
      set exp_filename [string trim $exp_filename]
      if { $exp_filename == "" } {
         tk_messageBox -message "Please specify an export filename" -type ok -icon warning
         return
      }
      set idx [.ddhexportselected.frmlist.listexp curselection]
      set id [lindex $ddhes_exportids $idx]
      set prefs_ddhexportselected_last_format $id
      eval ac3d ddhexportselected_go $id "\"$exp_filename\""
   }
   pack $frm.btnapply -side left -fill x -expand 1

   button $frm.btncancel -text "Close" -command {
      destroy .ddhexportselected
   }
   pack $frm.btncancel -side right -fill x -expand 1

   # Status label
   set frm [frame .ddhexportselected.frmstatus]
   pack $frm -side top -fill both -expand 1
   entry $frm.entstatus -textvariable ddhes_status -width $statuswidth -state readonly
   pack $frm.entstatus -side left -fill x -expand 1

}

proc ddhexportselected_dialog {} {

   global ac_platform

   if ![winfo exists .ddhexportselected] {
      ddhexportselected_makeframe
   }

   wm deiconify .ddhexportselected
   centre_window_on_screen .ddhexportselected
   if { $ac_platform == "Mac" } {
	   update idletasks
	   exposeUI .ddhexportselected
   }

}

